#ifndef _SYSTEM_TFT_RP2040
#define _SYSTEM_TFT_RP2040

#include <rp2040.h>
#include <stdio.h>
#include <string.h>
#include "tft_rp2040.ext"
#include "dma_tft.h"

#define BIT(x) (1<<x)
#define LOGO_ADRESSE  0x10100000  // im EEPROM

#define DEF_SYSCLOCK  150000000   // default
#define MHZ_12         12000000   // default
#define MHZ_10         10000000   // TCXO or ext. clock

#define MHZ_FAKTOR      1000000   // 1e6
#define MS_TEILER       1000      // us -> ms

enum {PRIO_HIGH = 0, PRIO_MID_HIGH, PRIO_MID_LOW, PRIO_LOW};

#define PIO_TIME_DIV   4          // PIO-divider
#define PLL_DIV1    4             // force high F_vco
#define PLL_DIV2    2             // default = 2; 1 => turbo-mode


#define LOCAL_LED       25        // on board

#define ADC_MAX         4095
#define ADC_FILTER      30        // ext. R-trimm

#define DEF_BAUDRATE    57600

#endif