/*
2022-05-14
Michael Nowak
http://www.mino-elektronik.de
Alle Angaben ohne Gewaehr !
*/

#pragma language=extended
#pragma segment="CSTACK"
#pragma segment="P1"
#include <rp2040.h>
#include <core_cm0plus.h>
#include <intrinsics.h>

extern void reset_handler( void );    // wird vom Debugger benoetigt

extern void NMI_Handler( void );
extern void HardFault_Handler( void );
extern void MemManage_Handler( void );
extern void BusFault_Handler( void );
extern void UsageFault_Handler( void );
extern void SVC_Handler( void );
extern void DebugMon_Handler( void );
extern void PendSV_Handler( void );
extern void SysTick_Handler( void );

extern void   TIMER_IRQ_0_IRQHandler(void);     //  0, TIMER_IRQ_0
extern void   TIMER_IRQ_1_IRQHandler(void);     //  1, TIMER_IRQ_1
extern void   TIMER_IRQ_2_IRQHandler(void);     //  2, TIMER_IRQ_2
extern void   TIMER_IRQ_3_IRQHandler(void);     //  3, TIMER_IRQ_3

extern void   PWM_IRQ_WRAP_IRQHandler(void);    //  4, PWM_IRQ_WRAP
extern void   USBCTRL_IRQ_IRQHandler(void);     //  5, USBCTRL_IRQ
extern void   XIP_IRQ_IRQHandler(void);         //  6, XIP_IRQ
extern void   PIO0_IRQ_0_IRQHandler(void);      //  7, PIO0_IRQ_0
extern void   PIO0_IRQ_1_IRQHandler(void);      //  8, PIO0_IRQ_1
extern void   PIO1_IRQ_0_IRQHandler(void);      //  9, PIO1_IRQ_0
extern void   PIO1_IRQ_1_IRQHandler(void);      // 10, PIO1_IRQ_1
extern void   DMA_IRQ_0_IRQHandler(void);       // 11, DMA_IRQ_0
extern void   DMA_IRQ_1_IRQHandler(void);       // 12, DMA_IRQ_1
extern void   IO_IRQ_BANK0_IRQHandler(void);    // 13, IO_IRQ_BANK0
extern void   IO_IRQ_QSPI_IRQHandler(void);     // 14, IO_IRQ_QSPI
extern void   SIO_IRQ_PROC0_IRQHandler(void);   // 15, SIO_IRQ_PROC0
extern void   SIO_IRQ_PROC1_IRQHandler(void);   // 16, SIO_IRQ_PROC1
extern void   CLOCKS_IRQ_IRQHandler(void);      // 17, CLOCKS_IRQ
extern void   SPI0_IRQ_IRQHandler(void);        // 18, SPI0_IRQ
extern void   SPI1_IRQ_IRQHandler(void);        // 19, SPI1_IRQ
extern void   UART0_IRQ_IRQHandler(void);       // 20, UART0_IRQ
extern void   UART1_IRQ_IRQHandler(void);       // 21, UART1_IRQ
extern void   ADC_IRQ_FIFO_IRQHandler(void);    // 22, ADC_IRQ_FIFO
extern void   I2C0_IRQ_IRQHandler(void);        // 23, I2C0_IRQ
extern void   I2C1_IRQ_IRQHandler(void);        // 24, I2C1_IRQ
extern void   RTC_IRQ_IRQHandler(void);         // 25, RTC_IRQ

typedef void( *intfunc )( void );
typedef union { intfunc __fun; 
                void * __ptr; 
              } intvec_elem;

#pragma location = ".intvec"

const intvec_elem __vector_table[] =
{
  { .__ptr = __sfe( "CSTACK" ) },
  // (intfunc)0x20042000,     // alternativ
  reset_handler,              // -15
  NMI_Handler,                // -14
  HardFault_Handler,          // -13
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  SVC_Handler,                // -5
  DebugMon_Handler,           // -4
  0,
  PendSV_Handler,             // -2
  SysTick_Handler,            // -1
  TIMER_IRQ_0_IRQHandler,     //  0  TIMER_IRQ_0
  TIMER_IRQ_1_IRQHandler,     //  1  TIMER_IRQ_1
  TIMER_IRQ_2_IRQHandler,     //  2  TIMER_IRQ_2
  TIMER_IRQ_3_IRQHandler,     //  3  TIMER_IRQ_3
  PWM_IRQ_WRAP_IRQHandler,    //  4  PWM_IRQ_WRAP
  USBCTRL_IRQ_IRQHandler,     //  5  USBCTRL_IRQ
  XIP_IRQ_IRQHandler,         //  6  XIP_IRQ
  PIO0_IRQ_0_IRQHandler,      //  7  PIO0_IRQ_0
  PIO0_IRQ_1_IRQHandler,      //  8  PIO0_IRQ_1
  PIO1_IRQ_0_IRQHandler,      //  9  PIO1_IRQ_0
  PIO1_IRQ_1_IRQHandler,      // 10  PIO1_IRQ_1
  DMA_IRQ_0_IRQHandler,       // 11  DMA_IRQ_0
  DMA_IRQ_1_IRQHandler,       // 12  DMA_IRQ_1
  IO_IRQ_BANK0_IRQHandler,    // 13  IO_IRQ_BANK0
  IO_IRQ_QSPI_IRQHandler,     // 14  IO_IRQ_QSPI
  SIO_IRQ_PROC0_IRQHandler,   // 15  SIO_IRQ_PROC0
  SIO_IRQ_PROC1_IRQHandler,   // 16  SIO_IRQ_PROC1
  CLOCKS_IRQ_IRQHandler,      // 17  CLOCKS_IRQ
  SPI0_IRQ_IRQHandler,        // 18  SPI0_IRQ
  SPI1_IRQ_IRQHandler,        // 19  SPI1_IRQ
  UART0_IRQ_IRQHandler,       // 20  UART0_IRQ
  UART1_IRQ_IRQHandler,       // 21  UART1_IRQ
  ADC_IRQ_FIFO_IRQHandler,    // 22  ADC_IRQ_FIFO
  I2C0_IRQ_IRQHandler,        // 23  I2C0_IRQ
  I2C1_IRQ_IRQHandler,        // 24  I2C1_IRQ
  RTC_IRQ_IRQHandler,         // 25  RTC_IRQ
};

#define LOOP   {while(1){}}

__weak void NMI_Handler(void) LOOP
__weak void HardFault_Handler(void) LOOP
__weak void MemManage_Handler(void) LOOP
__weak void BusFault_Handler(void) LOOP
__weak void UsageFault_Handler(void) LOOP
__weak void SVC_Handler(void) LOOP
__weak void DebugMon_Handler(void) LOOP
__weak void PendSV_Handler(void) LOOP
__weak void SysTick_Handler(void) LOOP

__weak void TIMER_IRQ_0_IRQHandler(void) LOOP
__weak void TIMER_IRQ_1_IRQHandler(void) LOOP
__weak void TIMER_IRQ_2_IRQHandler(void) LOOP
__weak void TIMER_IRQ_3_IRQHandler(void) LOOP

__weak void PWM_IRQ_WRAP_IRQHandler(void) LOOP
__weak void USBCTRL_IRQ_IRQHandler(void) LOOP
__weak void XIP_IRQ_IRQHandler(void) LOOP

__weak void PIO0_IRQ_0_IRQHandler(void) LOOP
__weak void PIO0_IRQ_1_IRQHandler(void) LOOP
__weak void PIO1_IRQ_0_IRQHandler(void) LOOP
__weak void PIO1_IRQ_1_IRQHandler(void) LOOP

__weak void DMA_IRQ_0_IRQHandler(void) LOOP
__weak void DMA_IRQ_1_IRQHandler(void) LOOP
__weak void IO_IRQ_BANK0_IRQHandler(void) LOOP
__weak void IO_IRQ_QSPI_IRQHandler(void) LOOP

__weak void SIO_IRQ_PROC0_IRQHandler(void) LOOP
__weak void SIO_IRQ_PROC1_IRQHandler(void) LOOP
__weak void CLOCKS_IRQ_IRQHandler(void) LOOP
__weak void SPI0_IRQ_IRQHandler(void) LOOP
__weak void SPI1_IRQ_IRQHandler(void) LOOP

__weak void UART0_IRQ_IRQHandler(void) LOOP
__weak void UART1_IRQ_IRQHandler(void) LOOP
__weak void ADC_IRQ_FIFO_IRQHandler(void) LOOP
__weak void I2C0_IRQ_IRQHandler(void) LOOP
__weak void I2C1_IRQ_IRQHandler(void) LOOP
__weak void RTC_IRQ_IRQHandler(void) LOOP



void __cmain( void );

void reset_handler( void )
{
  __set_MSP(*(uint32_t *)__vector_table );  // Master SP setzen
  SCB->VTOR = (uint32_t)__vector_table;     // unbedingt setzen!
  __cmain();
}
