#ifndef DMA_TFT_H
#define DMA_TFT_H

#include <stdio.h>
#include <stdint.h>

enum {PUSH_ZOOM, POP_ZOOM, CLR_ZOOM,  // Befehle fuer push-pop-Finktionen
      PUSH_XY, POP_XY, CLR_XY,
      PUSH_FONT, POP_FONT, CLR_FONT,
      PUSH_COLOR, POP_COLOR, CLR_COLOR};

#define DMA_KANAL_TFT 10            // oberen Kanal verwenden
#define DMA_KANAL_LINIE 11

// fr WQVGA 480 x 272
#define SIZE_X			480             // eff. angezeigte Spalten
#define SIZE_Y			272             // eff. angezeigte Zeilen
#define THP			    30		          // Hsync lnge
#define	TVP			    3		            // Vsync lnge in H-Zeilen
#define MAX_X			  (SIZE_X-1)
#define MAX_Y			  (SIZE_Y-1)

#define BILDBREITE	SIZE_X
#define BILDHOEHE		SIZE_Y
#define BILDGROESSE ((BILDBREITE * BILDHOEHE))

#define H_LINE_LEN	(BILDBREITE)    // gesamte Zeile

#define BLINKEN	    0x80	          // in der Farbe enthalten
#define TRANSPARENT	0x40	          // in der Farbe enthalten

#define Z_LEN	      8		            // Zeichenlnge
#define Z_H		      16		          // Zeichenhhe

#define SCHWARZ		  0x00
#define ROT			    0x03
#define GRUEN			  0x0c
#define BLAU			  0x30
#define WEISS			  (ROT+BLAU+GRUEN)
#define GELB			  (ROT+GRUEN)
#define TUERKIS			(0x2d)
#define VIOLETT			(BLAU+GRUEN)
#define HELLGRAU    0x2a
#define DUNKELGRAU  0x15

extern uint8_t bildspeicher[2][BILDGROESSE];   // normal und blinkend

#define MIT_BLINKEN             // Blinken braucht zwei Bildeiten: 261120 Byte RAM
#define MIN_HELLIGKEIT  0       // lt. Tabelle
#define MAX_HELLIGKEIT  8       // lt. Tabelle
#define SCHRIFT_BREITE	8		    // typ. Zeichenlnge
#define SCHRIFT_HOEHE	  16		  // typ. Zeichenhhe
#define MAX_ZOOM	      15
#define MIN_ZOOM	      1

#define MAX_ZOOM_STACK  20      // LIFO Tiefe
#define MAX_XY_STACK    20      // LIFO Tiefe
#define MAX_FONT_STACK  20      // LIFO Tiefe
#define MAX_COLOR_STACK 20      // LIFO Tiefe

#define ZEICHEN_LAENGE	  aktuelle_schrift[0]     // Zeichenlnge lt. Zeichensatz
#define ZEICHEN_HOEHE		  aktuelle_schrift[1]     // Zeichenhhe dto.

// ein paar Steuezeichen
#define GLOCKE  7
#define LF      10
#define RTN     13
#define HOME    0x0b
#define CLEAR   0x0c
#define ESC     27

#endif